//+------------------------------------------------------------------+
//|                                               AllPivots_v3.8.mq4 |
//|                                Copyright  2014, TrendLaboratory |
//|            http://finance.groups.yahoo.com/group/TrendLaboratory |
//|                                   E-mail: igorad2003@yahoo.co.uk |
//+------------------------------------------------------------------+
#property copyright "Copyright  2014, TrendLaboratory"
#property link      "http://finance.groups.yahoo.com/group/TrendLaboratory"

#property indicator_chart_window

//---- input parameters
extern string  set1              = "--- Main settings ---";
extern string  TimeFrame         =  "D1";                //TimeFrame(eg. D1,W1,YR)     
extern string  UniqueName        =  "AllPivots";         //Unique Name
extern int     Length            =  5;                   //Length in periods(eg. 2= 2 days)  
extern int     PivotMode         =  3;                   //Pivot Mode:  0-Standard(BasePrice=5)
                                                         //             1-Camarilla(BasePrice=0)    
                                                         //             2-Demark's Pivots
                                                         //             3-Fibo relative and Avg Range Levels
                                                         //             4-Fibo absolute(in pips)
                                                         //             5-Woodie's Pivots(BasePrice=7)
extern string  PivotValues       = "0;0.382;0.618;1";    //Pivot values(ratios)
extern int     MedianMode        =  0;                   //Median Mode: 0-off,1-on 
extern int     RangeMode         =  0;                   //Range Mode:  0-Hi/Lo Range;
                                                         //             1-UpRange=High-BasePrice, DnRange=BasePrice-Low 
                                                         //             2-Range=Close-Close[1]
extern int     AvgPeriod         =  1;                   //Avg Period  
                                                                           
extern int     BasePrice         =  5;                   //Base Price (0...7) (1 for today's Open)
extern int     BaseHourShift     =  2;                   //Base Hour Shift(eg.0-start of the day)
extern int     SessionStartHour  =  0;                   //Session Start Hour(eg. 9 for DAX,0-for Forex)
extern int     SessionEndHour    =  0;                   //Session End Hour(eg. 22 for DAX,0-for Forex)


extern string  set2              = "--- Visual settings ---";
extern int     GradientColorMode =  1;                   //0-off,1-on
extern color   MainPivotColor    =  Yellow;
extern int     MainPivotWidth    =  2;
extern color   UpperLevelColor   =  DodgerBlue;
extern color   LowerLevelColor   =  Red;
extern int     LineStyle         =  STYLE_SOLID;
extern int     LineWidth         =  1;
extern int     MedianStyle       =  STYLE_DOT;
extern int     MedianWidth       =  0;

extern bool    ShowPivotValues   =  false;
extern string  FontName          =  "Arial";
extern int     FontSize          =  8;
extern int     DescriptionPlace  =  0;                  //0-on the left,1-in the middle,2-on the right
extern int     CommentMode       =  0;                  //0-off,1-on


//---- indicator buffers
double uprange[];
double dnrange[];
double pivotprice[];
double pivottime[];
double pivotshift[];
double high[];
double low[];
double open[];
double close[];
double prevopen[];


int      TF, shift, num, time1, time2, pBars, size, upLineR, upLineG, upLineB, dnLineR, dnLineG, dnLineB, ppLineR, ppLineG, ppLineB;
bool     fTime;
datetime prevTime, last_timecurrent;
double   point, ratios[], P, R[], S[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
{
   fTime = true;
   
   IndicatorBuffers(7);
   SetIndexBuffer(0,   uprange); SetIndexStyle(0,DRAW_NONE);
   SetIndexBuffer(1,   dnrange);
   SetIndexBuffer(2,pivotprice);
   SetIndexBuffer(3,pivotshift);
   SetIndexBuffer(4, pivottime);
   SetIndexBuffer(5,      high);
   SetIndexBuffer(6,       low);
 

   TF = stringToTimeFrame(TimeFrame);
   
   last_timecurrent = TimeCurrent();
   
   size = StrToDoubleArray(PivotValues,ratios,";"); 
   
   switch(PivotMode)
   {
   case 0:  size = 4; break;
   case 1:  size = 6; break;
   case 2:  size = 1; break;
   case 5:  size = 4; break;
   }
   
     
   ArrayResize(R,size);
   ArrayResize(S,size);
   
   colorToRGB(UpperLevelColor,upLineR,upLineG,upLineB);
   colorToRGB(LowerLevelColor,dnLineR,dnLineG,dnLineB);
   colorToRGB(MainPivotColor ,ppLineR,ppLineG,ppLineB);
   
  

return(0);
}

//+------------------------------------------------------------------+
//| Custor indicator deinitialization function                       |
//+------------------------------------------------------------------+   
int deinit()
{
   ObjectDel(UniqueName);
   Comment("");
   return(0);
}
//+------------------------------------------------------------------+
//| AllPivots_v3.7                                                   |
//+------------------------------------------------------------------+
int start()
{
   int upColor1, upColor2, upColor3, dnColor1, dnColor2, dnColor3;
   datetime tftime[];
   
   if(TF == 525600) datetime curTime = StrToTime(Year() + ".01.01");  
   else curTime = iTime(NULL,TF,0);
   
   point = Point * MathPow(10,Digits%2);
    
   if(ArraySize(open) != Bars) 
   {
   ArraySetAsSeries(prevopen,false); ArraySetAsSeries(open,false); ArraySetAsSeries(close,false); 
   ArrayResize(prevopen,Bars); ArrayResize(open,Bars); ArrayResize(close,Bars);
   ArraySetAsSeries(prevopen,true); ArraySetAsSeries(open,true); ArraySetAsSeries(close,true);
   }
   
   
   if((curTime != prevTime && pBars > 0 && Bars > pBars) || fTime)  
   {
   ObjectDel(UniqueName);
      
      if(TF >= 10080) 
      {
      int i = 0, cnt = 0;
           
         while(i <= Bars-2 && cnt < Length+AvgPeriod) 
         {
         i++;   
            if((TF == 525600 && TimeYear(Time[i]) != TimeYear(Time[i+1]))||(TF == 43200 && TimeMonth(Time[i]) != TimeMonth(Time[i+1]))||(TF == 10080 && TimeDayOfWeek(Time[i]) < 2 && TimeDayOfWeek(Time[i+1]) == 5)) 
            {
            cnt++;
            ArrayResize(tftime,cnt);
            tftime[cnt-1] = Time[i];
            }  
         }
      }
      
         
      for (shift=0;shift<=Length+AvgPeriod;shift++)
      {
         
         if(TF >= 10080) 
         {
         datetime starthour = tftime[shift] + SessionStartHour*3600;
         pivottime[shift] = starthour + BaseHourShift*3600; 
         }
         else 
         {
         starthour = iTime(NULL,TF,shift) + SessionStartHour*3600;
         pivottime[shift] = Time[iBarShift(NULL,0,starthour) - BaseHourShift*60/Period()]; 
         }
     
         if(TimeDayOfWeek(pivottime[shift]) == 0) 
         {
         datetime dtime = pivottime[shift];    
         int day = 0;   
            while(day != 1)
            {
            dtime+=60*60;
            day = TimeDayOfWeek(dtime);   
            }
         pivottime[shift] = dtime;
         }
      
      pivotshift[shift] = iBarShift(NULL,0,pivottime[shift],false);
      }
   
   
   if(TF < 10080 && pivottime[0] != iTime(NULL,0,pivotshift[0])) return(0); 
       
      for (shift=0;shift<Length+AvgPeriod;shift++)
      {
      int length = pivotshift[shift+1] - pivotshift[shift];
      
      
      open[shift]  = iOpen(NULL,0,pivotshift[shift]);
      high[shift]  = High[iHighest(NULL,0,MODE_HIGH,length,pivotshift[shift]+1)];
      low[shift]   = Low [iLowest (NULL,0,MODE_LOW ,length,pivotshift[shift]+1)];
      close[shift] = iClose(NULL,0,pivotshift[shift]+1);   
      
      prevopen[shift] = iOpen(NULL,0,pivotshift[shift]+length);
     
         if(PivotMode == 2)
         {
            if(close[shift] < prevopen[shift]) double x = high[shift] + 2*low[shift] + close[shift];
            else
            if(close[shift] > prevopen[shift]) x = 2*high[shift] + low[shift] + close[shift];
            else x = high[shift] + low[shift] + 2*close[shift];
         
            pivotprice[shift] = x/4; 
         }
         else
         pivotprice[shift] = basePrice(BasePrice,prevopen[shift],open[shift],high[shift],low[shift],close[shift]);
      }
      
      for (shift=0;shift<Length+AvgPeriod;shift++)
      {
      
         switch(RangeMode)
         {
         case 0:  uprange[shift] = high[shift] - low[shift];
                  dnrange[shift] = uprange[shift]; 
                  break;
         
         case 1:  uprange[shift] = high[shift] - pivotprice[shift];
                  dnrange[shift] = pivotprice[shift] - low[shift]; 
                  break;
         
         case 2:  uprange[shift] = MathAbs(close[shift] - close[shift+1]);
                  dnrange[shift] = uprange[shift]; 
                  break;         
         }
      }
              
      for (shift=0;shift<Length;shift++)
      {
      double upR1 = 0, dnR1 = 0, upRavg = 0, dnRavg = 0;
      
      for(i=0;i<AvgPeriod;i++) {upR1 += uprange[i+shift]/AvgPeriod; dnR1 += dnrange[i+shift]/AvgPeriod;}   
           
      upRavg  = NormalizeDouble(upR1,Digits);  
      dnRavg  = NormalizeDouble(dnR1,Digits);      
      
      time1   = pivottime[shift];    
         
         if(shift==0)
         { 
            if(SessionEndHour == 0)
            {
               if(TimeDayOfWeek(iTime(NULL,TF,0)) == 1 && TF == 1440) time2 = iTime(NULL,TF,0) + TF*60 + 3600*BaseHourShift;
               else
               time2 = pivottime[shift] + TF*60;
            }
            else
            {
               if(TF >= 10080) time2 = tftime[shift] + TF*60 + SessionEndHour*3600; 
               else time2 = iTime(NULL,TF,shift) + SessionEndHour*3600; 
            
            }
         }
         else
         time2 = pivottime[shift-1];
         
      if(ShowPivotValues) string ratio0 = "(0.000)"; else ratio0 = ""; 
      
      P  = pivotprice[shift];
      int start = 0;
      
         if(DescriptionPlace == 0) int desctime = time1 + 60*6*Period();
         else
         if(DescriptionPlace == 1) desctime = time1 + (time2 - time1)/2; 
         else
         if(DescriptionPlace == 2) desctime = time2 - 60*6*Period();
                  
         if(findInArray(ratios,0) >= 0)
         {
         PlotLine(UniqueName+" PP["+shift+"]",P,MainPivotColor,MainPivotWidth,LineStyle);
                 
         PlotText(UniqueName+"value PP["+shift+"]","PP="+DoubleToStr(P,Digits)+" "+TimeFrame+ratio0,desctime,P,FontSize,FontName,0,MainPivotColor); 
                  
         if(PivotMode == 3 || PivotMode == 4) start = 1;
         }       
         
         for(i=start;i<size;i++)
         {
         if(GradientColorMode == 1) double coeff = (1 - (i+1.0)/size); else coeff = 0;  
         
            if(PivotMode == 0)
            {
            if(i == 0 && findInArray(ratios,1) >= 0) R[i] = NormalizeDouble(2*P -                    low[shift] ,Digits);       
            if(i == 1 && findInArray(ratios,2) >= 0) R[i] = NormalizeDouble(  P +   (high[shift] -   low[shift]),Digits);   
            if(i == 2 && findInArray(ratios,3) >= 0) R[i] = NormalizeDouble(2*P +   (high[shift] - 2*low[shift]),Digits);
            if(i == 3 && findInArray(ratios,4) >= 0) R[i] = NormalizeDouble(  P + 2*(high[shift] -   low[shift]),Digits);            
            }
            else
            if(PivotMode == 1)
            {
            if(i == 0 && findInArray(ratios,1) >= 0) R[i] = NormalizeDouble(P + upRavg*1.1/12.0,Digits);       
            if(i == 1 && findInArray(ratios,2) >= 0) R[i] = NormalizeDouble(P + upRavg*1.1/6.0 ,Digits);   
            if(i == 2 && findInArray(ratios,3) >= 0) R[i] = NormalizeDouble(P + upRavg*1.1/4.0 ,Digits);
            if(i == 3 && findInArray(ratios,4) >= 0) R[i] = NormalizeDouble(P + upRavg*1.1/2.0 ,Digits);            
            if(i == 4 && findInArray(ratios,5) >= 0) R[i] = NormalizeDouble((high[shift]/low[shift]*close[shift] + R[3])/2,Digits);
            if(i == 5 && findInArray(ratios,6) >= 0) R[i] = NormalizeDouble( high[shift]/low[shift]*close[shift],Digits);
            }
            else
            if(PivotMode == 2)
            {
            if(i == 0 && findInArray(ratios,1) >= 0) R[i] = NormalizeDouble(2*P - low[shift],Digits);    
            }
            else
            if(PivotMode == 3)
            {
            if(ratios[i] > 0) R[i] = NormalizeDouble(P + ratios[i]*upRavg,Digits);  
            }
            else
            if(PivotMode == 4)
            if(ratios[i] > 0) R[i] = NormalizeDouble(P + ratios[i]*point,Digits);  
            else
            if(PivotMode == 5)
            {
            if(i == 0 && findInArray(ratios,1) >= 0) R[i] = NormalizeDouble(2*P  +                low[shift] ,Digits);       
            if(i == 1 && findInArray(ratios,2) >= 0) R[i] = NormalizeDouble(  P  + (high[shift] - low[shift]),Digits);   
            if(i == 2 && findInArray(ratios,3) >= 0) R[i] = NormalizeDouble(R[1] + (high[shift] - low[shift]),Digits);
            if(i == 3 && findInArray(ratios,4) >= 0) R[i] = NormalizeDouble(R[2] + (high[shift] - low[shift]),Digits);            
            }
                 
         upColor1 = upLineR + coeff*(ppLineR - upLineR);
         upColor2 = upLineG + coeff*(ppLineG - upLineG);
         upColor3 = upLineB + coeff*(ppLineB - upLineB);
         
         if(ShowPivotValues) string ratioR = "("+DoubleToStr(ratios[i],3)+")"; else ratioR = "";
         
            if(R[i] > 0)
            {
            if((PivotMode == 3 || PivotMode == 4) && start == 1) int rnum = i; else rnum = i+1;
            PlotLine(UniqueName+" R"+rnum+"["+shift+"]",R[i],rgbToColor(upColor1,upColor2,upColor3),LineWidth,LineStyle);
         
            if(PivotMode == 1) string rname = "H"; else rname = "R"; 
            PlotText(UniqueName+"value R"+rnum+"["+shift+"]",rname+rnum+"="+DoubleToStr(R[i],Digits)+" "+TimeFrame+ratioR,desctime,R[i],FontSize,FontName,0,rgbToColor(upColor1,upColor2,upColor3)); 
            }
            
            if(MedianMode > 0 && R[i] > 0)
            {         
            if(i == start) double mr = (R[i] + P)/2; else mr = (R[i] + R[i-1])/2;
            PlotLine(UniqueName+" mR"+num+"["+shift+"]",mr,rgbToColor(upColor1,upColor2,upColor3),MedianWidth,MedianStyle);
            
            PlotText(UniqueName+"value mR"+num+"["+shift+"]","m"+rname+num+"="+DoubleToStr(mr,Digits)+" "+TimeFrame+ratioR,desctime,mr,FontSize,FontName,0,rgbToColor(upColor1,upColor2,upColor3)); 
            }      
//----            
            if(PivotMode == 0)
            {
            if(i == 0 && findInArray(ratios,1) >= 0) S[i] = NormalizeDouble(2*P -      high[shift]              ,Digits);       
            if(i == 1 && findInArray(ratios,2) >= 0) S[i] = NormalizeDouble(  P -   (  high[shift] - low[shift]),Digits);   
            if(i == 2 && findInArray(ratios,3) >= 0) S[i] = NormalizeDouble(2*P -   (2*high[shift] - low[shift]),Digits);
            if(i == 3 && findInArray(ratios,4) >= 0) S[i] = NormalizeDouble(  P - 2*(  high[shift] - low[shift]),Digits);            
            }
            else
            if(PivotMode == 1)
            {
            if(i == 0 && findInArray(ratios,1) >= 0) S[i] = NormalizeDouble(P - dnRavg*1.1/12.0,Digits);       
            if(i == 1 && findInArray(ratios,2) >= 0) S[i] = NormalizeDouble(P - dnRavg*1.1/6.0 ,Digits);   
            if(i == 2 && findInArray(ratios,3) >= 0) S[i] = NormalizeDouble(P - dnRavg*1.1/4.0 ,Digits);
            if(i == 3 && findInArray(ratios,4) >= 0) S[i] = NormalizeDouble(P - dnRavg*1.1/2.0 ,Digits);            
            if(i == 4 && findInArray(ratios,5) >= 0) S[i] = NormalizeDouble((2*close[shift] - high[shift]/low[shift]*close[shift] + S[3])/2,Digits);
            if(i == 5 && findInArray(ratios,6) >= 0) S[i] = NormalizeDouble( 2*close[shift] - R[5],Digits);
            }
            else
            if(PivotMode == 2)
            {
            if(i == 0 && findInArray(ratios,1) >= 0) S[i] = NormalizeDouble(2*P - high[shift],Digits);    
            }
            else
            if(PivotMode == 3)
            { 
            if(ratios[i] > 0) S[i] = NormalizeDouble(P - ratios[i]*dnRavg,Digits);
            }
            else 
            if(PivotMode == 4) 
            {
            if(ratios[i] > 0) S[i] = NormalizeDouble(P - ratios[i]*point,Digits);
            }
            else
            if(PivotMode == 5)
            {
            if(i == 0 && findInArray(ratios,1) >= 0) S[i] = NormalizeDouble(2*P  -               high[shift] ,Digits);       
            if(i == 1 && findInArray(ratios,2) >= 0) S[i] = NormalizeDouble(  P  - (high[shift] - low[shift]),Digits);   
            if(i == 2 && findInArray(ratios,3) >= 0) S[i] = NormalizeDouble(S[1] - (high[shift] - low[shift]),Digits);
            if(i == 3 && findInArray(ratios,4) >= 0) S[i] = NormalizeDouble(S[2] - (high[shift] - low[shift]),Digits);            
            }
         
         dnColor1 = dnLineR + coeff*(ppLineR - dnLineR);
         dnColor2 = dnLineG + coeff*(ppLineG - dnLineG);
         dnColor3 = dnLineB + coeff*(ppLineB - dnLineB);
                  
         if(ShowPivotValues) string ratioS = "(-"+DoubleToStr(ratios[i],3)+")"; else ratioS = ""; 
         
            if(S[i] > 0)
            {
            if((PivotMode == 3 || PivotMode == 4) && start == 1) num = i; else num = i+1;
            PlotLine(UniqueName+" S"+num+"["+shift+"]",S[i],rgbToColor(dnColor1,dnColor2,dnColor3),LineWidth,LineStyle);
            
            if(PivotMode == 1) string sname = "L"; else sname = "S"; 
            PlotText(UniqueName+"value S"+num+"["+shift+"]",sname+num+"="+DoubleToStr(S[i],Digits)+" "+TimeFrame+ratioS,desctime,S[i],FontSize,FontName,0,rgbToColor(dnColor1,dnColor2,dnColor3)); 
            }
            
            if(MedianMode > 0 && S[i] > 0)
            {         
            if(i == start) double ms = (S[i] + P)/2; else ms = (S[i] + S[i-1])/2;
            PlotLine(UniqueName+" mS"+num+"["+shift+"]",ms,rgbToColor(dnColor1,dnColor2,dnColor3),MedianWidth,MedianStyle);
           
            PlotText(UniqueName+"value mS"+num+"["+shift+"]","m"+sname+num+"="+DoubleToStr(ms,Digits)+" "+TimeFrame+ratioR,desctime,ms,FontSize,FontName,0,rgbToColor(dnColor1,dnColor2,dnColor3)); 
            }      
         }
   
         if(shift == 0 && CommentMode > 0)
         Comment("\n\n","Average: upRange = ",upRavg/point," dnRange =",dnRavg/point);                                                       
       
        
      }
   
   fTime    = false;
   prevTime = curTime;
   pBars    = Bars;
   }      
        
   return(0);
}
//+------------------------------------------------------------------+

// ----
void PlotLine(string name,double value,color clr,int width,int style)
{
   bool res = ObjectCreate(name,OBJ_TREND,0,time1,value,time2,value);
   ObjectSet(name, OBJPROP_WIDTH, width);
   ObjectSet(name, OBJPROP_STYLE, style);
   ObjectSet(name, OBJPROP_RAY  , false);
   ObjectSet(name, OBJPROP_BACK , true);
   ObjectSet(name, OBJPROP_COLOR, clr);
}        

void PlotText(string name,string text,datetime time,double price,int _size,string font,bool back,color clr)
{
   ObjectCreate(name,OBJ_TEXT,0,time,price);
   ObjectSetText(name,text,_size,font,clr);
   ObjectSet(name,OBJPROP_BACK,back);
}

//+------------------------------------------------------------------+
int StrToDoubleArray(string str, double &a[], string delim=",", int init=0)  
//+------------------------------------------------------------------+
//  Breaks down a single string into double array 'a' (elements delimited by 'delim')
//  e.g. string is "1,2,3,4,5";  if delim is "," then the result will be
//  a[0]=1.0   a[1]=2.0   a[2]=3.0   a[3]=4.0   a[4]=5.0
//  Unused array elements are initialized by value in 'init' (default is 0)
{  
   int z1=-1, z2=0;
   
   if(str == "") return(0);  
   if(StringRight(str,1) != delim) str = str + delim;
   
   int strcnt = StringFindCount(str,delim);
   
   ArrayResize(a,strcnt);
   
   for(int i=0;i<strcnt;i++) a[i] = init;
   
   for(i=0;i<strcnt;i++)  
   {
   z2 = StringFind(str,delim,z1+1);
   if(z2 > z1 + 1) a[i] = StrToNumber(StringSubstr(str,z1 + 1,z2 - z1 - 1));
   if(z2 >= StringLen(str) - 1) break;
   z1 = z2;
   }
  
   return(strcnt);
}

string StringRight(string str, int n=1)
//+------------------------------------------------------------------+
// Returns the rightmost N characters of STR, if N is positive
// Usage:    string x=StringRight("ABCDEFG",2)  returns x = "FG"
//
// Returns all but the leftmost N characters of STR, if N is negative
// Usage:    string x=StringRight("ABCDEFG",-2)  returns x = "CDEFG"
{
   if (n > 0)  return(StringSubstr(str,StringLen(str) - n,n));
   if (n < 0)  return(StringSubstr(str,-n,StringLen(str) - n));
  
   return("");
}

double StrToNumber(string str)  
//+------------------------------------------------------------------+
// Usage: strips all non-numeric characters out of a string, to return a numeric (double) value
// valid numeric characters are digits 0,1,2,3,4,5,6,7,8,9, decimal point (.) and minus sign (-)
// Example: StrToNumber("the balance is $-34,567.98") returns the numeric value -34567.98
{  
   int    dp    = -1;
   int    sgn   = 1;
   double snum  = 0.0;
  
   for (int i=0; i<StringLen(str); i++)  
   {
   string s = StringSubstr(str,i,1);
    if (s == "-")  sgn = -sgn;   else
    if (s == ".")  dp = 0;       else
      if (s >= "0" && s <= "9")  
      {
      if (dp >= 0)  dp++;
      if (dp > 0) snum = snum + StrToInteger(s)/MathPow(10,dp);
      else
      snum = snum*10 + StrToInteger(s);
      }
   }
   
   return(snum*sgn);
}

int StringFindCount(string str, string str2)
//+------------------------------------------------------------------+
// Returns the number of occurrences of STR2 in STR
// Usage:   int x = StringFindCount("ABCDEFGHIJKABACABB","AB")   returns x = 3
{
   int c = 0;
   for (int i=0; i<StringLen(str); i++)
      if (StringSubstr(str,i,StringLen(str2)) == str2)  c++;
   return(c);
}



bool ObjectDel(string name)
{
   int _GetLastError = 0;
     
   while(ObjFind(name,0,0) > 0)
   {
      int obtotal = ObjectsTotal();
      
      for (int i = 0; i < obtotal;i++)
      {
         if (StringFind(ObjectName(i),name,0) >= 0)
         {
            if (!ObjectDelete(ObjectName(i)))
            {
            _GetLastError = GetLastError();
            Print( "ObjectDelete( \"",ObjectName(i),"\" ) - Error #", _GetLastError );
            }
         }
      }
   }      
   return(true);
}


//-----
int ObjFind(string name,int start, int inum)
{
   int cnt = 0;
   
   for (int i = 0; i < ObjectsTotal();i++)
      if (StringFind(ObjectName(i),name,start) == inum) cnt+=1;
   
   return(cnt);
}

int      TFmin[] = {1,5,15,30,60,240,1440,10080,43200,525600};
string   TFs[]   = {"M1","M5","M15","M30","H1","H4","D1","W1","MN","YR"};

int stringToTimeFrame(string tfs)
{
   tfs = StringUpperCase(tfs);
   for (int i=ArraySize(TFmin)-1;i>=0;i--)
      if (tfs == TFs[i] || tfs == "" + TFmin[i]) return(TFmin[i]);
    
   return(Period());
}

string StringUpperCase(string str)
{
   string s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
   int _char = StringGetChar(s, length);
      if((_char > 96 && _char < 123) || (_char > 223 && _char < 256)) s = StringSetChar(s, length, _char - 32);
      else 
      if(_char > -33 && _char < 0) s = StringSetChar(s, length, _char + 224);
   }
   
   return(s);
}

int rgbToColor(int clrR, int clrG, int clrB)
{
   return (256*(256*clrB + clrG) + clrR);
}

void colorToRGB(color clr,int& clrR, int& clrG, int& clrB)
{
   clrR = clr&0x000000FF;
   clrG = (clr>>8)&0x000000FF;
   clrB = (clr>>16)&0x000000FF; 
}

double basePrice(int mode,double prevo,double o,double h, double l,double c)
{

   switch(mode)
   {
   case 0:  return(c); 
   case 1:  return(o);
   case 2:  return(h);
   case 3:  return(l);
   case 4:  return((h+l)/2);
   case 5:  return((h+l+c)/3);
   case 6:  return((h+l+2*c)/4);
   case 7:  return((h+l+2*o)/4);
   }
   
   return(0);
}

double findInArray(double& array[],double value)
{
   for(int i=0;i<ArraySize(array);i++) 
      if(array[i] == value) return(i); 

   return(-1);
}
    